package net.lecnam.info.ex2;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {
   
    public static void main(String[] args) throws IOException {
        System.out.println("Server is running");
        
        ServerSocket ss = new ServerSocket(55000);
        System.out.println("Waiting for a connection...");
        Socket s = ss.accept();
        System.out.println("Client connected");
        System.out.println("Local port: " + s.getLocalPort());
        System.out.println("Remote port: " + s.getPort());        
        System.out.println("Local IP: " + s.getLocalAddress());
        System.out.println("Remote IP: " + s.getInetAddress());
        InputStream is = s.getInputStream();
        OutputStream os = s.getOutputStream();
        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        PrintWriter writer = new PrintWriter(new BufferedOutputStream(os), true);
        String message = reader.readLine();
        if (!message.equals("hello")) throw new IOException("'hello' expected");
        writer.println("hello");
        System.out.println("hello");
        message = reader.readLine();
        if (!message.equals("name")) throw new IOException("'name' expected");        
        String name = reader.readLine();
        writer.println("bye");
        System.out.println("bye");
        writer.println(name);
        System.out.println(name);
        message = reader.readLine();
        if (!message.equals("bye")) throw new IOException("'bye' expected");    
        System.out.println("Closing");
        is.close();
        os.close();
        ss.close();
        s.close();
    }

}
