package net.lecnam.info;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

public class Client {

	public static void main(String[] args) throws UnknownHostException, IOException {
		System.out.println("Client is running");
		Socket s = new Socket("localhost", 55000);
		System.out.println("Connection established");
		System.out.println("Local port:" + s.getLocalPort());
		System.out.println("Local IP:" + s.getLocalAddress());
		System.out.println("Remote port:" + s.getPort());
		System.out.println("Remote IP:" + s.getInetAddress());
		//
		InputStream is = s.getInputStream(); 
		OutputStream os = s.getOutputStream();
		os.write(42);
		int result = is.read();
		System.out.println("Result :" + result);
		
		System.out.println("Closing");
		s.close();
	}

}
