package net.lecnam.info.ex2;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.Socket;

public class Client {

    public static void main(String[] args) throws IOException {
        System.out.println("Client is running");

        System.out.println("Connecting to server...");
        Socket s = new Socket("localhost", 55000);
        System.out.println("Connected.");
        System.out.println("Local port: " + s.getLocalPort());
        System.out.println("Remote port: " + s.getPort());
        System.out.println("Local IP: " + s.getLocalAddress());
        System.out.println("Remote IP: " + s.getInetAddress());
        InputStream is = s.getInputStream();
        OutputStream os = s.getOutputStream();
        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
        PrintWriter writer = new PrintWriter(new BufferedOutputStream(os), true);
        writer.println("hello");
        System.out.println("hello");
        String answer = reader.readLine();
        if (!answer.equals("hello")) {
            throw new IOException("'hello' expected");
        }
        writer.println("names");        
        System.out.println("name");
        writer.println("Tom");        
        System.out.println("Tom");
        answer = reader.readLine();
        if (!answer.equals("bye")) {
            throw new IOException("'bye' expected");
        }
        String name = reader.readLine();
        if (!name.equals("Tom")) {
            throw new IOException("'Tom' expected");
        }
        writer.println("bye");        
        System.out.println("bye");
        System.out.println("Closing.");
        is.close();
        os.close();
        s.close();

    }

}
